# -*- coding: utf-8 -*-
from setuphelpers import *


unopkg_path = makepath(programfiles, "LibreOffice", "program", "unopkg.com")


def install():
    extension_name = glob.glob(f"Grammalecte-fr-v{control.get_software_version()}.oxt")[0]

    if not isfile(unopkg_path):
        error("ERROR: Couldn't find path to unopkg.com, verify your LibreOffice installation")

    # run(f'"{unopkg_path}" --help') for further information
    run(f'"{unopkg_path}" add --shared "{extension_name}"')


def audit():
    extension_name = f"Grammalecte-fr-v{control.get_software_version()}.oxt"

    if not isfile(unopkg_path):
        error("ERROR: Couldn't find path to unopkg.com, verify your LibreOffice installation")

    result = run(f'"{unopkg_path}" list --shared "{extension_name}"')
    if extension_name in result:
        return "OK"
    else:
        return "ERROR"


def uninstall():
    extension_name = f"Grammalecte-fr-v{control.get_software_version()}.oxt"

    if not isfile(unopkg_path):
        error("ERROR: Couldn't find path to unopkg.com, verify your LibreOffice installation")

    run(f'"{unopkg_path}" remove --shared "{extension_name}"')
